From 3b97e0362488ccdbb2cc5c44fe597e101e9b9787 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Wed, 14 Dec 2022 11:22:07 +0530
Subject: [PATCH v1 19/25] Change pg_ndistinct_in to allow non-throw error
 reporting

---
 src/backend/statistics/mvdistinct.c       |  2 +-
 src/test/regress/expected/type_sanity.out | 12 ++++++++++++
 src/test/regress/sql/type_sanity.sql      |  3 +++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/backend/statistics/mvdistinct.c b/src/backend/statistics/mvdistinct.c
index 9b216af517f..088c37ca2db 100644
--- a/src/backend/statistics/mvdistinct.c
+++ b/src/backend/statistics/mvdistinct.c
@@ -339,7 +339,7 @@ statext_ndistinct_deserialize(bytea *data)
 Datum
 pg_ndistinct_in(PG_FUNCTION_ARGS)
 {
-	ereport(ERROR,
+	ereturn(fcinfo->context, (Datum) 0,
 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			 errmsg("cannot accept a value of type %s", "pg_ndistinct")));
 
diff --git a/src/test/regress/expected/type_sanity.out b/src/test/regress/expected/type_sanity.out
index 7ea63338d99..d20bf8b7c5d 100644
--- a/src/test/regress/expected/type_sanity.out
+++ b/src/test/regress/expected/type_sanity.out
@@ -868,3 +868,15 @@ SELECT pg_input_error_message('1', 'pg_mcv_list');
  cannot accept a value of type pg_mcv_list
 (1 row)
 
+SELECT pg_input_is_valid('1', 'pg_ndistinct');
+ pg_input_is_valid 
+-------------------
+ f
+(1 row)
+
+SELECT pg_input_error_message('1', 'pg_ndistinct');
+           pg_input_error_message           
+--------------------------------------------
+ cannot accept a value of type pg_ndistinct
+(1 row)
+
diff --git a/src/test/regress/sql/type_sanity.sql b/src/test/regress/sql/type_sanity.sql
index 15bcd0aa761..9bbec68082c 100644
--- a/src/test/regress/sql/type_sanity.sql
+++ b/src/test/regress/sql/type_sanity.sql
@@ -613,3 +613,6 @@ SELECT pg_input_error_message('1 99999', 'int2vector');
 
 SELECT pg_input_is_valid('1', 'pg_mcv_list');
 SELECT pg_input_error_message('1', 'pg_mcv_list');
+
+SELECT pg_input_is_valid('1', 'pg_ndistinct');
+SELECT pg_input_error_message('1', 'pg_ndistinct');
-- 
2.18.0

